## vtk9 9.2.6+dfsg1

=== debian/changelog ===
vtk9 (9.2.6+dfsg1-1+exp2) experimental; urgency=medium

  * Team upload.
  * Merge changes from 9.1.0+really9.1.0+dfsg2-6.
  * Add license paragraph for public-domain license.

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 22 Jun 2023 13:22:18 +0200

vtk9 (9.2.6+dfsg1-1+exp1) experimental; urgency=medium

  * [965a45d] New upstream version 9.2.6+dfsg1

 -- Anton Gladky <gladk@debian.org>  Sat, 25 Mar 2023 15:34:05 +0100
