=== Documentation/docs/requirements.txt ===
furo
myst-parser[linkify]
sphinx
sphinx-autodoc2
sphinx-copybutton
sphinx-design
sphinxcontrib-moderncmakedomain
pygments
pyparsing
