=== IO/XML/CMakeLists.txt ===
set(classes
  vtkRTXMLPolyDataReader
  vtkXMLCompositeDataReader
  vtkXMLCompositeDataWriter
  vtkXMLDataObjectWriter
  vtkXMLDataReader
  vtkXMLDataSetWriter
  vtkXMLFileReadTester
  vtkXMLGenericDataObjectReader
  vtkXMLHierarchicalBoxDataFileConverter
  vtkXMLHierarchicalBoxDataReader
  vtkXMLHierarchicalBoxDataWriter
  vtkXMLHierarchicalDataReader
  vtkXMLHyperTreeGridReader
  vtkXMLHyperTreeGridWriter
  vtkXMLImageDataReader
  vtkXMLImageDataWriter
  vtkXMLMultiBlockDataReader
  vtkXMLMultiBlockDataWriter
  vtkXMLMultiGroupDataReader
  vtkXMLPDataObjectReader
  vtkXMLPDataReader
  vtkXMLPHyperTreeGridReader
  vtkXMLPImageDataReader
  vtkXMLPPolyDataReader
  vtkXMLPRectilinearGridReader
  vtkXMLPStructuredDataReader
  vtkXMLPStructuredGridReader
  vtkXMLPTableReader
  vtkXMLPUnstructuredDataReader
  vtkXMLPUnstructuredGridReader
  vtkXMLPartitionedDataSetCollectionReader
  vtkXMLPartitionedDataSetReader
  vtkXMLPolyDataReader
  vtkXMLPolyDataWriter
  vtkXMLReader
  vtkXMLRectilinearGridReader
  vtkXMLRectilinearGridWriter
  vtkXMLStructuredDataReader
  vtkXMLStructuredDataWriter
  vtkXMLStructuredGridReader
  vtkXMLStructuredGridWriter
  vtkXMLTableReader
  vtkXMLTableWriter
  vtkXMLUniformGridAMRReader
  vtkXMLUniformGridAMRWriter
  vtkXMLUnstructuredDataReader
  vtkXMLUnstructuredDataWriter
  vtkXMLUnstructuredGridReader
  vtkXMLUnstructuredGridWriter
  vtkXMLWriter
  vtkXMLWriterBase
  vtkXMLWriterC)

vtk_module_add_module(VTK::IOXML
  CLASSES ${classes})
vtk_add_test_mangling(VTK::IOXML
  # Ignore mangling for the C API
  EXEMPTIONS
    vtkXMLWriterC_)
