=== Filters/Points/Testing/Python/CMakeLists.txt ===
vtk_add_test_python(
  TestConnectedPointsFilter.py
  TestDensifyPointCloudFilter.py
  TestDensifyPointCloudFilter2.py
  TestEllipsoidalGaussianKernel.py
  TestEuclideanClusterExtraction.py
  TestEuclideanClusterExtraction2.py
  TestExtractEnclosedPoints.py
  TestExtractPoints.py
  TestFitImplicitFunction.py
  TestHierarchicalBinningFilter.py
  TestPCACurvatureEstimation.py
  TestPCACurvatureEstimation2.py
  TestPCANormalEstimation.py
  TestPCANormalEstimation2.py
  TestPointDensityFilter.py
  TestPointDensityGradient.py
  TestPointInterpolator.py
  TestPointInterpolator2.py
  TestPointInterpolator2D.py
  TestPointInterpolator2D2.py
  TestPointOccupancyFilter.py
  TestPointSmoothingFilter.py
  TestPointSmoothingFilter2.py
  TestPointSmoothingFilter3.py
  TestProjectPointsToPlane.py
  TestRadiusOutlierRemoval.py
  TestSPHInterpolator.py
  TestSPHInterpolator2D.py
  TestSPHInterpolatorWithCutoff.py
  TestSignedDistanceFilter.py
  TestStatisticalOutlierRemoval.py
  TestUnsignedDistanceFilter.py
  TestVoxelGridFilter.py
  )
